# coding: utf-8

"""
    Chino.io :: Scriba API

    An API to create and search immutable, legally-validated Audit Logs.<br>Provided by Chino.io - https://www.chino.io  # noqa: E501

    OpenAPI spec version: v1
    Contact: tech-support@chino.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from chinoscriba.api_client import ApiClient


class StatsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def stats_read(self, **kwargs):  # noqa: E501
        """Retrieve customer statistics  # noqa: E501

        Get some figures about logs saved in the system for the user, such as total counts, oldest log datetime, month usage.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stats_read(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool ui: include in the stats those logs generated by interactions with the Chino.io Console web UI
        :param int t: Amount of days to retrieve stats for. Can be 30, 60 or 90.
        :return: Stat
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.stats_read_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.stats_read_with_http_info(**kwargs)  # noqa: E501
            return data

    def stats_read_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieve customer statistics  # noqa: E501

        Get some figures about logs saved in the system for the user, such as total counts, oldest log datetime, month usage.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.stats_read_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param bool ui: include in the stats those logs generated by interactions with the Chino.io Console web UI
        :param int t: Amount of days to retrieve stats for. Can be 30, 60 or 90.
        :return: Stat
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ui', 't']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method stats_read" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'ui' in params:
            query_params.append(('ui', params['ui']))  # noqa: E501
        if 't' in params:
            query_params.append(('t', params['t']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Basic', 'BearerJwt']  # noqa: E501

        return self.api_client.call_api(
            '/stats', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Stat',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
